From 6dc1f63a5693c33c8123b17a09a81ebaaf446e44 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 21 2017 09:44:19 +0000
Subject: [PATCH 3/6] Make widget views emit the template signals


And add a way to inspect rendered templates in unit tests.

---

diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index a3cc5f7..c430043 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -6,6 +6,7 @@ from datetime import datetime, timedelta
 import os
 
 import munch
+from flask import template_rendered
 from os.path import dirname
 import unittest
 
@@ -155,3 +156,18 @@ class FakeAuthorization(object):
         self.avatar = 'avatar_src_url'
         self.nickname = username
         self.username = username
+
+
+# http://flask.pocoo.org/docs/0.11/signals/#subscribing-to-signals
+
+@contextmanager
+def captured_templates(app):
+    recorded = []
+
+    def record(sender, template, context, **extra):
+        recorded.append((template, context))
+    template_rendered.connect(record, app)
+    try:
+        yield recorded
+    finally:
+        template_rendered.disconnect(record, app)
diff --git a/hubs/widgets/halp/views.py b/hubs/widgets/halp/views.py
index 46d530e..b4ce683 100644
--- a/hubs/widgets/halp/views.py
+++ b/hubs/widgets/halp/views.py
@@ -3,6 +3,7 @@ from __future__ import unicode_literals, absolute_import
 import datetime
 import flask
 import time
+from flask.signals import template_rendered, before_render_template
 
 from hubs.models import Hub
 from hubs.views.utils import get_hub
@@ -218,8 +219,8 @@ def add_view(hub):
         for param in widget.get_parameters()
         )
     initial["hubs"] = [hub.name]
-    return template.render(
-        mode="add",
-        url=post_url,
-        initial=initial,
-    )
+    context = dict(mode="add", url=post_url, initial=initial)
+    before_render_template.send(widget, template=template, context=context)
+    output = template.render(**context)
+    template_rendered.send(widget, template=template, context=context)
+    return output
diff --git a/hubs/widgets/view.py b/hubs/widgets/view.py
index 19ff77c..943302d 100644
--- a/hubs/widgets/view.py
+++ b/hubs/widgets/view.py
@@ -1,5 +1,6 @@
 from __future__ import unicode_literals, absolute_import
 
+from flask.signals import template_rendered, before_render_template
 from flask.views import View
 
 
@@ -97,4 +98,10 @@ class WidgetView(View):
         instance = self._get_instance(*args, **kwargs)
         context = self.get_context(instance, *args, **kwargs)
         context.update(self.get_extra_context(instance, *args, **kwargs))
-        return self.get_template().render(**context)
+        template = self.get_template()
+        before_render_template.send(
+            self.widget, template=template, context=context)
+        output = template.render(**context)
+        template_rendered.send(
+            self.widget, template=template, context=context)
+        return output

